<?php

/**
 * com_plan_destinos_comisionados actions.
 *
 * @package    controlComisiones
 * @subpackage com_plan_destinos_comisionados
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class com_plan_destinos_comisionadosActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_PLAN_DESTINOS_COMISIONA_V',
        'COM_PLAN_COMISIONES_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_PLAN_COMISIONES_V' =>
        array(
            'id_plan_comisiones' => 'COM_PLAN_DESTINOS_COMISIONA_V',
            'vigencia' => 'COM_PLAN_DESTINOS_COMISIONA_V'
        ),
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_PLAN_DESTINOS_COMISIONA_V' =>
        array(
            'num_doc' => 'num_doc',
            'razsoc' => 'razsoc',
            'num_doc,||, - ,||,razsoc' => 'completo_ter',
            'tipter_ter' => 'tipter_ter',
            'tipoter_text' => 'tipoter_text',
            'descripcion_trans' => 'descripcion_trans',
            'municipio' => 'municipio',
            'codmun_text' => 'codmun_text',
            'depto' => 'depto',
            'zona_roja' => 'zona_roja',
            'observaciones_mun' => 'observaciones_mun',
            'nitocc' => 'nitocc',
            'id_plan_comisiones' => 'id_plan_comisiones',
            'vigencia' => 'vigencia',
            'codmun' => 'codmun',
            'orden' => 'orden',
            'estado' => 'estado',
            'id_transporte' => 'id_transporte'
        ),
        'COM_PLAN_COMISIONES_V' =>
        array(
            'estado' => 'estado_comision',
            'firmado' => 'firmado_comision',
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'vigencia', 'id_plan_comisiones', 'nitocc', 'codmun'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_PLAN_DESTINOS_COMISIONA_V' =>
        array(
            'num_doc,a' => array('!=' => array(-1)),
            'num_doc,b' => array('=' => array('num_doc')),
            'id_plan_comisiones' => array('=' => array('id_plan_comisiones')),
            'vigencia' => array('=' => array('vigencia')),
            'estado' => array('=' => array('estado')),
            'id_transporte' => array('=' => array('id_transporte')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas


    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = null; //identificador de la tabla
    protected $id_names = array('nitocc', 'id_plan_comisiones', 'vigencia', 'codmun'); //llave primaria
    protected $field_names = array('orden', 'estado', 'id_transporte'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_PLAN_DESTINOS_COMISIONADOS'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_plan_comisiones'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['nitocc'] = $request['num_doc'];
        }

        //accion update
        if ($Action == "UPDATE") {
            $request['nitocc'] = $request['num_doc'];
        }

        //accion remove
        if ($Action == "REMOVE") {
            $request['nitocc'] = $request['num_doc'];
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */


        return $errors;
    }

    /**
     * Actualiza una fila por los parametros de entrada ---- override del método update para permitir hacer edición parcial por columnas
     *
     * @param sfWebRequest $request
     */
    public function executeUpdate(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
            if ($value == 'null') {
                unset($request[$key]);
            }
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();
        /**
         * VALIDAR ERRORES DE PROCEDIMIENTO
         */
        try {

            //leer variable gwt
            $id_plan_comisiones = $request['id_plan_comisiones'];
            $vigencia = $request['vigencia'];
            $nitocc = $request['num_doc'];
            $codmun = $request['codmun'];

            if (isset($request['estado']) && $request['estado'] == 'true') {
                $estado = '1';
            } else {
                $estado = '0';
            }

            /**
             * Actualiza el detalle del pedido - 2018104
             */
            $sql = <<<EOD
UPDATE com_plan_destinos_comisionados
SET estado   = '$estado'                    
WHERE id_plan_comisiones = $id_plan_comisiones
AND vigencia = $vigencia
AND nitocc = '$nitocc' 
AND codmun = '$codmun' 
EOD;

            CN_TABLE::executeSQL($sql, true);

            $this->conn->commit();
            $this->status = 0;
            $this->list_data = array();
        } catch (Exception $e) {


            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();
            $mensaje = "[UPDATE sfAPIActions] ERROR Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'operacion' => "UPDATE"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        }
    }

}
